
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>TCP协议详解（理论篇） / iVAN</title>

    <meta name="description" content="TCP协议详解（理论篇） 本文章摘自红黑联盟 http://www.2cto.com/net/201208/149347.html 供大家学习交流 TCP协议详解 1.    与UDP不同的是,TCP提供了一种面向连接的.可靠的字节流服务.面向连接比较好理解,就是连接双方在通信前需要预先建立一条连接,这犹如实际生活中的打电话.助于可靠性,TCP协议中涉及了诸多规则来保障通信链路的可靠性,总结起来,主要有以下几点:       (1)应用数据分割成TCP认为最适合发送的数据块.这部分是通过&quot;MSS&quot;(最 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">TCP协议详解（理论篇）</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>本文章摘自红黑联盟 http://www.2cto.com/net/201208/149347.html 供大家学习交流</p>
<p>TCP协议详解</p>
<p>1.    与UDP不同的是，TCP提供了一种面向连接的、可靠的字节流服务。面向连接比较好理解，就是连接双方在通信前需要预先建立一条连接，这犹如实际生活中的打电话。助于可靠性，TCP协议中涉及了诸多规则来保障通信链路的可靠性，总结起来，主要有以下几点：</p>
<p>      （1）应用数据分割成TCP认为最适合发送的数据块。这部分是通过“MSS”（最大数据包长度）选项来控制的，通常这种机制也被称为一种协商机制，MSS规定了TCP传往另一端的最大数据块的长度。值得注意的是，MSS只能出现在SYN报文段中，若一方不接收来自另一方的MSS值，则MSS就定为536字节。一般来讲，在不出现分段的情况下，MSS值还是越大越好，这样可以提高网络的利用率。</p>
<p>      （2）重传机制。设置定时器，等待确认包。</p>
<p>      （3）对首部和数据进行校验。</p>
<p>      （4）TCP对收到的数据进行排序，然后交给应用层。</p>
<p>      （5）TCP的接收端丢弃重复的数据。</p>
<p>      （6）TCP还提供流量控制。（通过每一端声明的窗口大小来提供的）</p>
<p>2. TCP包的首部：  www.2cto.com  </p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvdXAuMmN0by5jb20vMjAxMi8wODIwLzIwMTIwODIwMDEwNjQ1NTkxLmpwZw==.jpg"><br />
 </p>
<p>（1）      若不计选项字段，TCP的首部占20个字节。</p>
<p>（2）      源端口号以及目的端口号用于寻找发端和接收端的进程，一般来讲，通过端口号和IP地址，可以唯一确定一个TCP连接，在网络<a href="http://www.2cto.com/kf" rel="external nofollow noreferrer">编程</a>中，通常被称为一个socket接口。</p>
<p>（3）      序号是用来标识从TCP发端向TCP接收端发送的数据字节流。</p>
<p>（4）      确认序号包含发送确认的一端所期望收到的下一个序号，因此，确认序号应该是上次已经成功收到数据字节序号加1.</p>
<p>（5）      首部长度指出了TCP首部的长度值，若不存在选项，则这个值为20字节。</p>
<p>（6）      标志位(flag)：</p>
<p>                URG: 紧急指针有效</p>
<p>                ACK：确认序号有效</p>
<p>                PSH：接收方应尽快将这个报文段交给应用层</p>
<p>                RST：重建连接</p>
<p>                SYN：同步序号用来发起一个连接</p>
<p>                FIN： 发端完成发送任务（主动关闭）    <br />
                    </p>
<p>【解释】</p>
<p>◆     TCP提供解决方式是为了使一端告诉另外一端某些“紧急数据”已经放置在普通的数据流中，让接收端对紧急数据做特别处理。此时，URG位被置为1，并且16位的紧急数据被置为一个正的偏移量，通过此偏移量与TCP首部中的序号字段相加，可以得出紧急数据的最后一个字节的序号，常见的应用有传输中断键（在通过telnet连接过程中）。</p>
<p>◆     RST: 复位字段被用于当一个报文发送到某个socket接口而出现错误时，TCP则会发出复位报文段。常见出现的情况有以下几种：  www.2cto.com  </p>
<p>发送到不存在的端口的连接请求：此时对方的目的端口并没有侦听，对于UDP，将会发出ICMP不可达的   错误信息，而对于TCP，将会发出设置RST复位标志位的数据报。异常终止一个连接：正常情况下，通过发送FIN去正常关闭一个TCP连接，但也有可能通过发送一个复位   报文段去中途释放掉一个连接。在socketAPI中通过设置socket选 项SO_LINGER去关闭这种异常关闭的情况。</p>
<p> </p>
<p>3. TCP的连接与终止过程：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvdXAuMmN0by5jb20vMjAxMi8wODIwLzIwMTIwODIwMDEwNjQ2ODQwLmpwZw==.jpg"><br />
 </p>
<p>（1）  三次握手：</p>
<p>         建立一个TCP连接，必须经历三次握手过程，其中发送第一个SYN的一端将执行主动打开，接收这个SYN并发回下一个SYN的另一端执行被动打开。</p>
<p>（2）  四次释放：</p>
<p>         要释放一个TCP连接，需要通过四次握手过程，这是由TCP的半关闭特性造成的，因为TCP连接时全双工的，因此，需要TCP两端要单独执行关闭。值得注意的是，主动关闭的一端在发送FIN之后，依然还能正常接收对方的数据，只是通知对方它已经没有数据需要发送了，同理，被动关闭的一端在收到FIN之后，仍然可以发送数据，直到它自身同样发出FIN之后，才停止发送数据。<br />
 </p>
<p>（3）  TCP连接的超时问题：</p>
<p>         完成一个TCP连接，中间涉及到一个超时的问题，大多数伯克利系统的超时时限为75s，Solaris9的超时时限为240s，因此，一般认为是在75-240之间。</p>
<p>【引申】在具体的实现中，如何由用户自己去完成设置socket连接超时时间？</p>
<p>【解决方法】目前实现socket超时连接主要是通过select来完成的。具体步骤如下：</p>
<p>    ◆     建立socket</p>
<p>    ◆     将socket设置为非阻塞模式（若是阻塞模式，那么时间设置就毫无意义）</p>
<p>    ◆     调用connect去进行连接</p>
<p>    ◆     使用select检查socket是否可写，并同时判断其结果（为什么是可写？因为需要检测socket是否收到ACK。）</p>
<p>    ◆     将socket转化为阻塞模式<br />
 </p>
<p>（4）TCP的半关闭  www.2cto.com  </p>
<p>         所谓“半关闭”，是指连接的一端在结束它的发送之后还能接收到对方发过来的数据的能力。具体表现在，当完成三次握手的双方，其中有一端发出FIN，此时它将进入半关</p>
<p>闭状态，此时它关闭了自身的发送功能，但是它依然可以接收到对方的数据，如对方发过来的ACK消息。那么在实际开发中，是怎么实现的呢？</p>
<p>这牵涉到系统中shutdown和close函数的区别问题。</p>
<p>        int shutdown(int s, int how)       &lt;sys/socket.h&gt;</p>
<p>         shutdown是用来终止参数s所指定的socket接口，参数how主要有以下几种情况：</p>
<p>         how = 0    终止读取操作</p>
<p>         how = 1    终止写入操作</p>
<p>         how = 2    终止读取和写入操作</p>
<p>         返回的errorcode可能有：</p>
<p>         EBADF  /* Bad file descriptor */</p>
<p>         ENOTSOCK  /* Socket operation on non-socket */</p>
<p>         ENOTCONN  /* Socket is not connected */<br />
 </p>
<p>【引用】</p>
<p>    Big difference between shutdown and close on a socket is thebehavior when the socket is shared by other processes.A shutdown() affects all copies of the socket whileclose() affects only the file descriptor in one process.</p>
<p>    Even if you close() a TCP socket, it won't necessarily beimmediately reusable anyway, since it will be in a TIME_WAITstate while the OS makes sure there's no outstandingpackets that might get confused as new information if you were to immediatelyreuse<br />
 that socket for something else.</p>
<p>【注意】</p>
<p>当shutdown关闭读取部分时，则会丢掉接收缓冲区中的任何数据，并关闭该端的连接，若是关闭写入部分，TCP则会发送剩余的数据，然后终止连接的写入端。</p>
<p> </p>
<p>4. TCP的状态变迁图：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvdXAuMmN0by5jb20vMjAxMi8wODIwLzIwMTIwODIwMDEwNjQ3ODA3LmpwZw==.jpg"><br />
 </p>
<p>几个状态解析：</p>
<p>（1）     TIME_WAIT状态</p>
<p>    这种状态也称为2MSL等待状态，MSL即一个报文段的最长生存时间，也就是报文在网络中被丢弃前的最长时间。那么为什么需要等待2倍的MSL呢？这是因为在TIME_WAIT状态之后，需要执行主动关闭，发送ACK，同时还需要加上一倍的MSL，为了等待对方的反馈结果（是否收到重发的FIN），这是因为再发送ACK之后，可能因为诸多原因而导致ACK发送失败，此时Server端会在此发送FIN。</p>
<p>     正常情况下，client在2MSL期间，对应的socket是不能再被使用的，但是在具体的实现中（如伯克利），则可以通过SO_REUSEADDR选项重用此接口。</p>
<p>（2）     FIN_WAIT_2状态</p>
<p>     当对方对自己发送的FIN进行了确认，此时将进入FIN_WAIT_2状态。</p>
<p>（3） CLOSE_WAIT状态与FIN_WAIT_1状态</p>
<p>     当连接中的一方收到对方发过来的FIN时，它将进入CLOSE_WAIT状态，而另一端则进入FIN_WAIT_1状态。  www.2cto.com  </p>
<p>    </p>
<p>5. TCP中流量控制机制——滑动窗口</p>
<p>      受到诸多因素的影响，如硬件（双方网卡吞吐量差异）、网络环境，网络极易出现各种各样的拥塞，目前所采取的措施主要有以下两种：改进拥塞算法以及控制发送端和接收端的流量。本节主要讲述如何在接收端和发送端进行流量控制。</p>
<p>（1）滑动窗口——接收端</p>
<p>      在讲解滑动窗口协议之前，可以回顾下最初人们为了在接收端实施流量控制所提出了的经典算法——停止等待算法，其核心思想是：接收端在收到一个数据报之后，停止接收新的数据报，直到发出ACK（对收到的数据报的确认）之后进行恢复。算法思想以及实现非常简单，但是却遇到一个效率的问题，特别是随着网络设备的数据处理能力得到了很大的提高，效率低下显得尤其明显，后来人们也尝试了多种改进措施，如本节的滑动窗口就是其中之一。</p>
<p>      其基本原理是：在接收端存在一个接收缓存区，用来接收来自于发送方的数据，只有当应用进程从接收缓存区中取出数据（可能只是部分）并发出其ACK后，才算作这部分数据已经接收，然后调节此时的滑动窗口大小。发送方根据返回的窗口大小，计算出所能发送的数据大小。因此，可以这么理解，滑动窗口算法是接收端作为主动方根据自身的缓存以及处理能力主动去调节对方的发送流量的一种调节算法。</p>
<p>      下面通过一个滑动窗口模型图了解下发送方是如何处理所收到的滑动窗口的？</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvdXAuMmN0by5jb20vMjAxMi8wODIwLzIwMTIwODIwMDEwNjQ4MzQ0LmpwZw==.jpg"><br />
 </p>
<p>在发送方依然存在一个缓存区（发送缓存区），其发送的数据可以是下面几种状态：</p>
<p>◆ 发送并确认 （1-3）</p>
<p>◆ 发送但未确认 （4-6）  www.2cto.com  </p>
<p>◆ 可以发送 （7-9）</p>
<p>◆ 不能够发送 （10以后）</p>
<p>      值得注意的是，滑动窗口是基于所收到的确认序列号的。当发送方根据所收到的确认序列号以及窗口大小，不断向后移动，并相应更新数据状态。</p>
<p>                                                                            </p>
<p>（2）滑动窗口——发送端（拥塞窗口）</p>
<p>     网络拥塞出现的原因是多方面的，除了收发两段的硬件差异之外，还与网络通信链路相关，如通信链路中转发<a href="http://www.2cto.com/net/router/" rel="external nofollow noreferrer">路由器</a>的缓存，试想这样一种情况，若发送端与接收端的处理能力以及吞吐能力很强，若它仅仅通过接收端所返回的滑动窗口大小，难以阻止数据报在被路由器转发过程中因为阻塞而被丢弃的情形，因为与发送端相连的路由器因为自身的缓冲空间的限制，难以存储并转发这么多数据而出现丢包现象。那么这种情况如何避免呢？最好的机制是中间的路由器也要参与给发送端反馈窗口大小的事情，也正是本节所说的拥塞窗口。</p>
<p>      综合上面的阐述，发送端会收到两个窗口大小，分别是来自于接收端和中间路由器，注意前者在每次的数据报中都会出现，而后者只是在网络中出现拥塞时由中间路由器发送。那么，发送方此时取接收端的窗口大小与拥塞窗口中的最小值作为发送上限值。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-28 19:55:16</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e8%b7%af%e7%94%b1%e5%99%a8/" title="路由器">路由器</a>, <a href="https://www.iamivan.net/tag/socket/" title="socket">socket</a>, <a href="https://www.iamivan.net/tag/%e7%ae%97%e6%b3%95/" title="算法">算法</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>TCP协议详解（理论篇）的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M12qP9p.html" rel="bookmark">《Linux高性能服务器编程》&mdash;&mdash;第3章 TCP协议详解   3&period;1 TCP服务的特点</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第3章 TCP协议详解 TCP协议是TCP/IP协议族中另一个重要的协议.和IP协议相比,TCP协议更靠近应用层,因此在应用程序中具有更强的可操作性.一些重要的socket选项都和TCP协议相关. 本章从如下四方面来讨论TCP协议: 不过在详细讨论TCP协议之前,我们先简单介绍一下TCP服务的特点,以及它和UDP服务的区别. 3.1 TCP服务的特点 传输层协议主要有两个:TCP协议和UDP协议.TCP协议相对于UDP协议的特点是:面向连接.字节流和可靠传输. 使用TCP协议通信的双方必须先建立			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPNqkZb.html" rel="bookmark">HTTP协议详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				HTTP是一个属于应用层的面向对象的协议,由于其简捷.快速的方式,适用于分布式超媒体信息系统.它于1990年提出,经过几年的使用与发 展,得到不断地完善和扩展.目前在WWW中使用的是HTTP/1.0的第六版,HTTP/1.1的规范化工作正在进行之中,而且HTTP-NG(Next Generation of HTTP)的建议已经提出. HTTP协议的主要特点可概括如下: 1.支持客户/服务器模式. 2.简单快速:客户向服务器请求服务时,只需传送请求方法和路径.请求方法常用的有GET.HEAD.PO			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ze7vV0M.html" rel="bookmark">SSL协议详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				SSL协议详解 背景介绍    最近在看&lt;密码学与网络安全&gt;相关的书籍,这篇文章主要详细介绍一下著名的网络安全协议SSL. 在开始SSl介绍之前,先给大家介绍几个密码学的概念和相关的知识. 1.密码学的相关概念 密码学(cryptography):目的是通过将信息编码使其不可读,从而达到安全性. 明文(plain text):发送人.接受人和任何访问消息的人都能理解的消息. 密文(cipher text):明文消息经过某种编码后,得到密文消息. 加密(encryption):将明文消息变成密文			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zOa7GvM.html" rel="bookmark">&lbrack;网络&rsqb;HTTP协议详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				[简介]                                         HTTP是一个属于应用层的面向对象的协议,由于其简捷.快速的方式,适用于分布式超媒体信息系统.它于1990年提出,经过几年的使用与发展,得到不断地完善和扩展.目前在WWW中使用的是HTTP/1.0的第六版,HTTP/1.1的规范化工作正在进行之中,而且HTTP-NG(Next Generation of HTTP)的建议已经提出. HTTP协议的主要特点可概括如下: 1.支持客户/服务器模式. 2.简单快速			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b3rDdAz.html" rel="bookmark">HTTP协议详解（真的很经典）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				HTTP协议详解(真的很经典) Author :清晨 引言 HTTP是一个属于应用层的面向对象的协议,由于其简捷.快速的方式,适用于分布式超媒体信息系统.它于1990年提出,经过几年的使用与发展,得到不断地完善和扩展.目前在WWW中使用的是HTTP/1.0的第六版,HTTP/1.1的规范化工作正在进行之中,而且HTTP-NG(Next Generation of HTTP)的建议已经提出. HTTP协议的主要特点可概括如下: 1.支持客户/服务器模式. 2.简单快速:客户向服务器请求服务时,只需			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p8ALdlz.html" rel="bookmark">JSP学习之------&amp;amp&semi;gt&semi;HTTP协议详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Author :Jeffrey  My Blog:http://blog.csdn.net/gueter/  引言                                        HTTP是一个属于应用层的面向对象的协议,由于其简捷.快速的方式,适用于分布式超媒体信息系统.它于1990年提出,经过几年的使用与发展,得到不断地完善和扩展.目前在WWW中使用的是HTTP/1.0的第六版,HTTP/1.1的规范化工作正在进行之中,而且HTTP-NG(Next Generation of			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5OZ8Ab.html" rel="bookmark">《Linux高性能服务器编程》&mdash;&mdash;第2章 IP协议详解   2&period;1 IP服务的特点</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第2章 IP协议详解 IP协议是TCP/IP协议族的核心协议,也是socket网络编程的基础之一.本章从两个方面较为深入地探讨IP协议: 由于32位表示的IP地址即将全部使用完,因此人们开发出了新版本的IP协议,称为IPv6协议,而原来的版本则称为IPv4协议.本章前面部分的讨论都是基于IPv4协议的,只在最后一节简要讨论IPv6协议. 在开始讨论前,我们先简单介绍一下IP服务. 2.1 IP服务的特点 IP协议是TCP/IP协议族的动力,它为上层协议提供无状态.无连接.不可靠的服务. 无状态(			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zVG19nb.html" rel="bookmark">Websocket协议详解及简单实例代码&lowbar;基础知识</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Websocket协议详解 关于websocket的协议是用来干嘛的,请参考其他文章. WebSocket关键词 HTML5协议,实时,全双工通信,长连接 WebSocket比传统Http的好处 客户端与服务端只建立一个TCP连接,可以使用更少的连接 WebSocket的服务端可以将数据推送到客户端,如实时将证券信息反馈到客户端(这个很关键),实时天气数据,比http请求响应模式更灵活 更轻量的协议头,减少数据传送量 数据帧格式 下图为手工打造的数据帧格式 /** * fin |masked |			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bBZKddb.html" rel="bookmark">socket-unix网络编程环境怎么配置&quest;我买了套接字联网api和tcp&sol;ip详解&comma;但是书上的代码都不能运行&period;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 unix网络编程环境怎么配置?我买了套接字联网api和tcp/ip详解,但是书上的代码都不能运行. 就下面这个代码,运行提示没有unp.h,找了个unp.h,但是还是提示什么各种数据类型重复定义.我到现在觉得是不是这本书写错了. #include &quot;unp.h&quot; int main(int argc, char **argv) { int sockfd, n; char recvline[MAXLINE + 1]; struct sockaddr_in servaddr; if			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMgmn1z.html" rel="bookmark" class="title">国外虚拟主机选购指南</a>
					<div>
						国外的虚拟主机和国内的相比有不少的优点,例如不用去备案,价格相对低廉,稳定性也好,虽然从国内访问速度稍微慢一些,但的确是一个低成本创建一个网站的好方案.国外的空间基本上是基于Linux+Apache+ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0boAXdp.html" rel="bookmark" class="title">用FireWorks手绘&OpenCurlyDoubleQuote;朵朵姑娘&rdquo;</a>
					<div>
						先费话一下,偶然在一日记本封面看到这个姑娘,一下就&quot;喜欢&quot;上了它.固稍微整顿一下,用Fireworks给整了出来!俗话说:文章本天成,妙手偶得之.这一过程是偶然的.如果你是FW爱好 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvKRyVp.html" rel="bookmark" class="title">Unity3D中Coroutine的用法</a>
					<div>
						unity3d开发中Coroutine到底是怎么用的? 昨天在测试的时候发生了很严重的当机事件,不管用什么Android的手机,在游玩过程中会不定时的无任何警示讯息自动跳出,从LogCat看讯息发现: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5AxQBp.html" rel="bookmark" class="title">PHP生成json和xml类型接口数据格式</a>
					<div>
						  在做数据接口时,我们通常要获取第三方数据接口或者给第三方提供数据接口,而这些数据格式通常是以XML或者JSON格式传输,本文将介绍如何使用PHP生成XML格式数据供第三方调用以及如何获取第三方提供 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLa8dAz.html" rel="bookmark" class="title">jQuery中使用data&lpar;&rpar;方法读取HTML5自定义属性data-&ast;实例</a>
					<div>
						 如果你使用jQuery类库,那么你可以非常愉悦的使用jquery的data()方法存取data-* 自定义属性,方法允许我们在DOM元素上绑定任意类型的数据,避免了循环引用的内存泄漏风险 主要的方法 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEW5v6p.html" rel="bookmark" class="title">什么原因导致电脑黑屏</a>
					<div>
						  分析原因:难道是病毒作怪了?不可能,还没有听说哪个病毒不让关机呢!于是再次开机,静观其变,这次发现开机时主机没有报警声,电源风扇正常,CPU风扇也正常,那是怎么回事?在没有其他办法的情况下,向朋友 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVNodmz.html" rel="bookmark" class="title">我国网民规模达6&period;32亿，半年共计新增网民1442万人</a>
					<div>
						一.网民规模 (一)总体网民规模 截至2014年6月,我国网民规模达6.32亿,半年共计新增网民1442万人.互联网普及率为46.9%,较2013年底提升了1.1个百分点. http://img1.c ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlKgvYb.html" rel="bookmark" class="title">windows-如何利用C&sol;C&plus;&plus;标准库编写跨平台的程序？</a>
					<div>
						问题描述 如何利用C/C++标准库编写跨平台的程序? 如题,最近公司给了个小任务,让在一个工程中找出符合某种条件的代码,并记录下行号. 听着好像比较简单,因为公司的项目在win,linux下有两个版本 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPkklDM.html" rel="bookmark" class="title">entitymanagerfactory-spring mvc配置问题，求好心人帮助。</a>
					<div>
						问题描述 spring mvc配置问题,求好心人帮助. 我在项目里配置了servlet-context.xml 配置了root-context.xml 为什么root-context.xml无法映射到 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYXB75b.html" rel="bookmark" class="title">iproute2 对决 net-tools</a>
					<div>
						iproute2 对决 net-tools 如今很多系统管理员依然通过组合使用诸如ifconfig.route.arp和netstat等命令行工具(统称为net-tools)来配置网络功能,解决网络故 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M60E5gz.html" rel="bookmark" class="title">C&num; 关于Jmail 发送html邮件的问题？</a>
					<div>
						问题描述 ///&lt;summary&gt;///多附件HTML邮件发送///&lt;/summary&gt;///&lt;paramname=&quot;fileList&quot;&gt;文件名 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7x8XKb.html" rel="bookmark" class="title">屡败的收购案：华友博弈&OpenCurlyDoubleQuote;门口的野蛮人&rdquo;</a>
					<div>
						&quot;只要华友股价再回落一点,我还将继续买进.&quot;5月21日,一位投资美股的人士向记者表示. 当日是华友股价大跌的日子,跌幅达15.25%,收于2.5美元.此前的两个多月,华友股价跌宕起 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeoaKOM.html" rel="bookmark" class="title">window&period;returnValue使用方法示例介绍&lowbar;javascript技巧</a>
					<div>
						window.showModalDialog是弹出模式窗口的方法 returnValue是javascript中html的window对象的属性,目的是返回窗口值,当用window.showModal ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBgnDKM.html" rel="bookmark" class="title">ASP如何转换成PHP  求高手帮助 （第一次来这里，新人啊。有木有人帮看看）</a>
					<div>
						问题描述 怎么样才能把以下代码转换成PHP啊?&lt;%FunctionGetHttpPage(HttpUrl,bm)IfIsNull(HttpUrl)=TrueOrHttpUrl=&quot;$Fa ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwJOdkp.html" rel="bookmark" class="title">web迷茫，求高手指点</a>
					<div>
						问题描述 本人初学java,只有一点C的基础.想做一个人人网第三方应用,像开心农场那种类型的.我要学习哪些知识?用什么工具开发比较好?我需要吧JavaSE过一遍吗?我不是做网站.OA之类的.大家都用什 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlLN28M.html" rel="bookmark" class="title">flex&plus;java开发的环境大家都是怎么搭建的？</a>
					<div>
						问题描述 我一年多没搞flex+java的开发了,现在需要搞个项目.myeclipse敢用么?担心商用被抓到.谁有最新的环境搭建教程给我一份吧 解决方案 我们公司用的myeclipse8.5+flex ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLgWkvM.html" rel="bookmark" class="title">中国联合航空 数据抓取</a>
					<div>
						问题描述 中国联合航空数据抓取现在最后一步老是出现问题说什么timeout有没有做过的请联系,前面的每一步的返回值我都对过都是可以的 解决方案 解决方案二:到底说什么timeout,你倒是说啊.解决方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq7lLRz.html" rel="bookmark" class="title">信用卡-有大神做过如何获取信yong卡账单的系统么？ 求指教</a>
					<div>
						问题描述 有大神做过如何获取信yong卡账单的系统么? 求指教 解决方案 没搞过.不过估计要向银行买服务吧 解决方案二: 银行没有服务提供, 现在尝试了可以模拟银行接口登录获取到					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8YnYlz.html" rel="bookmark" class="title">Linux IO 之 系统缓存&lpar;pdflush &amp;amp&semi; dirty page&rpar; 及 扩展知识</a>
					<div>
						[原文] http://www.phpfans.net/article/htmls/201010/MzEwNzAx.html 延伸阅读: cgroup限制用户IOPS,共用文件系统,引发的思考: ht ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAkyPKz.html" rel="bookmark" class="title">PHP代码判断设备是手机还是平板电脑&lpar;两种方法&rpar;&lowbar;php实例</a>
					<div>
						现在移动互联网越来越发达,很多的网站都普及了手机端浏览,为了更好的让网页在手机端显示,我们都选择了使用CSS媒体查询制作响应式模版,但这也有弊端,例如某些网站的结构是CMS类型的,太多的内容要显示,而 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyW1A8z.html" rel="bookmark" class="title">ThinkPHP自动验证失败的解决方法&lowbar;php技巧</a>
					<div>
						复制代码 代码如下: /* * 登陆 */ public function Login(){ if($_POST['submit']){ $DB = D('Login');//自定义Model处理 / ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pL5EkWz.html" rel="bookmark" class="title">web service 让我们来入门&lpar;一&rpar;</a>
					<div>
						web service 让我们来入门也许web serivce的出现一定形式对Dcom和CORBA来说,对其rpc一定应用带入平台无关性,确实在远程调用函数为已所用通过soap传递,对其不同的平台,移 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvY4QNb.html" rel="bookmark" class="title">怎么更好更快的学习seo网站优化</a>
					<div>
						怎么更好更快的学习seo网站优化 1.灵活使用Google和百度等搜索引擎 很多朋友一定会说,Google和百度我都会啊,这个还要学吗?不就是在搜索框上输入自己想找的信息的相关关键字吗?这太简单了.如 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjoElmM.html" rel="bookmark" class="title">六大走红网络流行语</a>
					<div>
						1.给力 中国北方土话,表示给劲.带劲的意思.&quot;给力&quot;一词最初的火热源于日本搞笑动漫&lt;西游记:旅程的终点&gt;中文配音版中悟空的一句抱怨:&quot;这就是天竺吗,不给力啊 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mrv5n6M.html" rel="bookmark" class="title">中关村软件园：中芬创新合作的探路者</a>
					<div>
						在芬兰举国欢庆独立百年之际,应芬兰共和国总统尼尼斯托邀请,国家主席习近平于4月4日开始对芬兰进行国事访问,开启了中芬关系新篇章. 创新驱动发展已成为中国的核心发展战略,中国已踏上了迈向世界创新强国的伟 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3Yqvgp.html" rel="bookmark" class="title">《Adobe Flash CS6中文版经典教程》&mdash;&mdash;1&period;2　了解工作区</a>
					<div>
						1.2 了解工作区 Adobe Flash Professional工作区包括位于屏幕顶部的命令菜单以及多种工具和面板,用来在影片中编辑和添加元素.你可以在Flash中为动画创建所有对象,也可以导入在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQWXROp.html" rel="bookmark" class="title">《Adobe Dreamweaver CS5中文版经典教程》&mdash;&mdash;1&period;8&emsp;使用&OpenCurlyDoubleQuote;属性&rdquo;检查器</a>
					<div>
						1.8 使用&quot;属性&quot;检查器 Adobe Dreamweaver CS5中文版经典教程一个对你的工作流程至关重要的工具是&quot;属性&quot;检查器.这个面板通常出现在工作区的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Yn7ap.html" rel="bookmark" class="title">王建宙：中国移动希望以CDR形式回归A股</a>
					<div>
						中移动股票昨日走势. 王建宙称,公司希望通过CDR的方式上市,因为CDR的程序更简单,且在监管上有较好的一致性. 本报讯 中国移动(00941.HK)董事长兼首席执行官王建宙昨日出席股东会后表示,公司 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLJOK0b.html" rel="bookmark" class="title">笔记本厂商遭遇报修门宏碁戴尔惠普投诉排前三</a>
					<div>
						本报记者 李壮 北京报道 最近,维权网发布的截止到7月1日的笔记本投诉统计报告显示,在北京地区,共接到笔记本投诉241宗,未解决率占比20.3%,投诉排名前三的品牌分别是宏碁.戴尔和惠普. 消失的保修 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQagOZb.html" rel="bookmark" class="title">美生物医药风投连旺两季 中印新兴市场被看好</a>
					<div>
						全美风险资本协会(NVCA)最近发布的二季度投资数据显示,风险投资对生命科学领域(生物技术和医疗设备行业)的投资再次处于遥遥领先的地位.今年一季度,生物医药领域投资即首度超出其他领域,成为最活跃和最受 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 12 q. 0.036 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
